package com.wang.mqtt;

import android.os.Bundle;
import android.support.design.widget.BottomNavigationView;
import android.support.v7.app.AppCompatActivity;
import android.support.annotation.NonNull;
import android.view.MenuItem;

public class MainActivity extends AppCompatActivity {

    private MonitorFragment monitorFragment;
    private SettingFragment settingFragment;

    private BottomNavigationView.OnNavigationItemSelectedListener mOnNavigationItemSelectedListener
            = new BottomNavigationView.OnNavigationItemSelectedListener() {

        @Override
        public boolean onNavigationItemSelected(@NonNull MenuItem item) {
            switch (item.getItemId()) {
                case R.id.navigation_home:

                    if (monitorFragment == null)
                        monitorFragment = new MonitorFragment();
                    //replace fragment
                    getSupportFragmentManager().beginTransaction().replace(R.id.fl_container, monitorFragment).commitAllowingStateLoss();
                    return true;
                case R.id.navigation_mine:

                    if( settingFragment == null){
                        settingFragment = new SettingFragment();
                    }
                    getSupportFragmentManager().beginTransaction().replace(R.id.fl_container, settingFragment).commitAllowingStateLoss();
                    return true;
            }
            return false;
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);


        monitorFragment = new MonitorFragment();
        getSupportFragmentManager().beginTransaction().add(R.id.fl_container, monitorFragment).commitAllowingStateLoss();


        BottomNavigationView navView = findViewById(R.id.nav_view);
        navView.setOnNavigationItemSelectedListener(mOnNavigationItemSelectedListener);
    }

}
