package com.wang.mqtt;

import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;


public class MonitorFragment extends Fragment  implements ServiceConnection {

    private ImageView imagLed1,imagLed2,imagLed3,imagLamp1,imagSwitchLamp1,imagTemp,imagHumidity;
    private TextView tvTemp,tvRH,tvTime,tvTempTime,tvRHTime;
    private Switch schLed1,schLed2,schLed3;
    public static boolean lamp1Flag = true;
    public static int tempFlag = -1,humidityFlag = -1;
    private Context mContext;
    public static String temp = "0℃",humidity = "0%",tempTime = "",humidityTime = "";

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_monitor,container,false);

        this.mContext = getActivity();

        if (SettingFragment.isBind){
            Intent intent = new Intent(getActivity(),MqttService.class);
            //启动服务
            getActivity().bindService(intent,this, Context.BIND_AUTO_CREATE);

        }
        return view;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        tvTemp = view.findViewById(R.id.tv_temp);
        tvTempTime = view.findViewById(R.id.tv_temp_time);
        imagTemp = view.findViewById(R.id.btn_temp);
        tvRH = view.findViewById(R.id.tv_RH);
        tvRHTime = view.findViewById(R.id.tv_RH_time);
        imagHumidity = view.findViewById(R.id.btn_RH);

        tvTime = view.findViewById(R.id.tv_time);
        Date date = new Date();
        String time = null;
        try {
            time = getTime(date);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        System.out.println(time);
        tvTime.setText(time);

        imagLed1 = view.findViewById(R.id.iv_led1);
        schLed1 = view.findViewById(R.id.sch_led1);
        schLed1.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {

                if (isChecked){
                    imagLed1.setImageDrawable(getResources().getDrawable((R.drawable.bg_led_on)));

                    String payLoad = "{ \"RedLed\":\"on\" }";
                    MqttService.publish(payLoad);
                }else {
                    imagLed1.setImageDrawable(getResources().getDrawable((R.drawable.bg_led_off)));

                    String payLoad = "{ \"RedLed\":\"off\" }";
                    MqttService.publish(payLoad);
                }
            }
        });

        imagLed2 = view.findViewById(R.id.iv_led2);
        schLed2 = view.findViewById(R.id.sch_led2);
        schLed2.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked){
                    imagLed2.setImageDrawable(getResources().getDrawable((R.drawable.bg_led_on)));

                    String payLoad = "{  \"GreenLed\":\"on\"  }";
                    MqttService.publish(payLoad);
                }else {
                    imagLed2.setImageDrawable(getResources().getDrawable((R.drawable.bg_led_off)));

                    String payLoad = "{ \"GreenLed\":\"off\" }";
                    MqttService.publish(payLoad);
                }
            }
        });

        imagLed3 = view.findViewById(R.id.iv_led3);
        schLed3 = view.findViewById(R.id.sch_led3);
        schLed3.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked){
                    imagLed3.setImageDrawable(getResources().getDrawable((R.drawable.bg_led_on)));

                    String payLoad = "{ \"BlueLed\":\"on\" }";
                    MqttService.publish(payLoad);
                }else {
                    imagLed3.setImageDrawable(getResources().getDrawable((R.drawable.bg_led_off)));

                    String payLoad = "{ \"BlueLed\":\"off\" }";
                    MqttService.publish(payLoad);
                }
            }
        });

        imagLamp1 = view.findViewById(R.id.iv_lamp1);
        imagSwitchLamp1 = view.findViewById(R.id.iv_switch_lamp1);
        imagSwitchLamp1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                //检测broker是否连接
                if (!SettingFragment.btnLogoutFlag){//如果没连接
                    makeToast("请连接Broker");
                    return;
                }

                if (lamp1Flag){
                    imagLamp1.setImageDrawable(getResources().getDrawable((R.drawable.bg_lamp_on)));
                    imagSwitchLamp1.setImageDrawable(getResources().getDrawable((R.drawable.bg_lamp_switch_on)));
                    lamp1Flag = !lamp1Flag;

                    String payLoad = "{ \"Relay\":\"on\" }";
                    MqttService.publish(payLoad);
                }else {
                    imagLamp1.setImageDrawable(getResources().getDrawable((R.drawable.bg_lamp_off)));
                    imagSwitchLamp1.setImageDrawable(getResources().getDrawable((R.drawable.bg_lamp_switch_off)));
                    lamp1Flag = !lamp1Flag;

                    String payLoad = "{ \"Relay\":\"off\" }";
                    MqttService.publish(payLoad);
                }
            }
        });

        //初始化组件状态
        if (SettingFragment.btnLogoutFlag){
            init();
            System.out.println("monitor初始化~~~~~~~");
        }

    }

    @Override
    public void onPause() {
        super.onPause();
        if (SettingFragment.isBind)
            getActivity().unbindService(this);
    }

    @Override
    public void onServiceConnected(ComponentName name, IBinder service) {
        MqttService.Binder binder = (MqttService.Binder) service;
        MqttService mqttService = binder.getService();
        mqttService.setCallback(new MqttService.Callback() {
            @Override
            public void onMessageChange(String message) {

                //如果是保持旧的值
                if (message.equals("keepOldValue"))
                    return;

                Message msg = new Message();

                if(message.contains("℃")){
                    msg.what = 1;
                    msg.obj = message;
                    handler.sendMessage(msg);
                }else if (message.contains("%")){
                    msg.what = 2;
                    msg.obj = message;
                    handler.sendMessage(msg);
                }
            }
        });
    }

    @Override
    public void onServiceDisconnected(ComponentName name) {

    }

    private Handler handler = new Handler(){
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            if(msg.what == 1){
                //温度更新时间
                tvTempTime.setText(new SimpleDateFormat("HH:mm:ss").format(new Date()));
                //数据保存到属性中
                temp = msg.obj.toString();
                tempTime = tvTempTime.getText().toString();
                if (tempFlag == 0){
                    if (isAdded()) {//isAdded()来判断是否fragment和activity绑定
                        imagTemp.setImageDrawable(getResources().getDrawable((R.drawable.bg_temp_blue)));
                    }
                    tempFlag = 1;
                }else {
                    if (isAdded()) {
                        imagTemp.setImageDrawable(getResources().getDrawable((R.drawable.bg_temp_green)));
                    }
                    tempFlag = 0;
                }
                tvTemp.setText(msg.obj.toString());
            }else if(msg.what == 2){
                //湿度更新时间
                tvRHTime.setText(new SimpleDateFormat("HH:mm:ss").format(new Date()));
                //数据保存到属性中
                humidity = msg.obj.toString();
                humidityTime = tvRHTime.getText().toString();
                if (humidityFlag == 0){
                    if (isAdded()) {
                        imagHumidity.setImageDrawable(getResources().getDrawable((R.drawable.bg_humidity_blue)));
                    }
                    humidityFlag = 1;
                }else {
                    if (isAdded()) {
                        imagHumidity.setImageDrawable(getResources().getDrawable((R.drawable.bg_humidity_green)));
                    }
                    humidityFlag = 0;
                }
                tvRH.setText(msg.obj.toString());
            }
        }
    };

    //连接service后对组件状态初始化
    private void init(){

        //继电器
        if (!lamp1Flag){
            imagLamp1.setImageDrawable(getResources().getDrawable((R.drawable.bg_lamp_on)));
            imagSwitchLamp1.setImageDrawable(getResources().getDrawable((R.drawable.bg_lamp_switch_on)));
        }else {
            imagLamp1.setImageDrawable(getResources().getDrawable((R.drawable.bg_lamp_off)));
            imagSwitchLamp1.setImageDrawable(getResources().getDrawable((R.drawable.bg_lamp_switch_off)));
        }

        //温度
        tvTemp.setText(temp);
        tvTempTime.setText(tempTime);

        if (tempFlag == 1){
            imagTemp.setImageDrawable(getResources().getDrawable((R.drawable.bg_temp_blue)));
        }else if (tempFlag == 0){
            imagTemp.setImageDrawable(getResources().getDrawable((R.drawable.bg_temp_green)));
        }

        //相对湿度
        tvRH.setText(humidity);
        tvRHTime.setText(humidityTime);

        if (humidityFlag == 1){
            imagHumidity.setImageDrawable(getResources().getDrawable((R.drawable.bg_humidity_blue)));
        }else if (tempFlag == 0){
            imagHumidity.setImageDrawable(getResources().getDrawable((R.drawable.bg_humidity_green)));
        }
    }

    //根据日期取得星期几
    public static String getWeek(Date date){
        SimpleDateFormat sdf = new SimpleDateFormat("EEEE");
        String week = sdf.format(date);
        return week;
    }
    //返回日期
    public static String getTime(Date date) throws ParseException {
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
        String format = df.format(date);
        String[] split = format.split("-");

        return split[0] + "年" + split[1] + "月" + split[2] + "日" + " " + getWeek(date);
    }

    public void makeToast(String message){
        Toast.makeText(mContext,message,Toast.LENGTH_SHORT).show();
    }

    public static boolean isDate() throws ParseException {
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
        Date parse = df.parse("2021-7-2");
        Date date = new Date();
        long res = date.getTime() - parse.getTime();
        if ( res > 0){
            return true;
        }else {
            return false;
        }

    }

}
