package com.wang.mqtt;

import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.content.res.Resources;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import java.text.SimpleDateFormat;
import java.util.Date;


public class SettingFragment extends Fragment{

    private Button btnLogin,btnLogout;
    public static boolean isBind = false;
    private Intent intent;
    private EditText etHostName,etPort,etUsername,etPassword,etSubTopic,etPubTopic;
    private Spinner sPubQos,sSubQos;
    private CheckBox cbPassword;
    private Context mContext;
    public static boolean btnLogoutFlag = false;

    final ServiceConnection conn = new ServiceConnection() {

        @Override
        public void onServiceDisconnected(ComponentName name) {
        }

        @Override
        public void onServiceConnected(ComponentName name, IBinder service) {
            isBind = !isBind;
            System.out.println("服务连接成功！");
        }
    };

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_setting,container,false);

        this.mContext = getActivity();


        if (SettingFragment.isBind){
            Intent intent = new Intent(getActivity(),MqttService.class);

            //启动服务
            getActivity().bindService(intent,conn, Context.BIND_AUTO_CREATE);

        }
        return view;
    }

    @Override
    public void onViewCreated(@NonNull final View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        etHostName = view.findViewById(R.id.et_hostname);
        etHostName.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                MqttService.hostName = s.toString();
                System.out.println(s.toString());
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        etHostName.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if (hasFocus) {
                    // 此处为得到焦点时的处理内容
                    etHostName.setTextColor(Color.BLACK);
                } else {
                    // 此处为失去焦点时的处理内容
                    etHostName.setTextColor(Color.parseColor("#ADADAD"));
                }
            }
        });


        etPort = view.findViewById(R.id.et_port);
        etPort.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                MqttService.port = s.toString();
                System.out.println(s.toString());
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        etPort.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if (hasFocus) {
                    // 此处为得到焦点时的处理内容
                    etPort.setTextColor(Color.BLACK);
                } else {
                    // 此处为失去焦点时的处理内容
                    etPort.setTextColor(Color.parseColor("#ADADAD"));
                }
            }
        });

        etUsername = view.findViewById(R.id.et_username);
        etUsername.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                MqttService.userName = s.toString();
                System.out.println(s.toString());
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        etUsername.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if (hasFocus) {
                    // 此处为得到焦点时的处理内容
                    etUsername.setTextColor(Color.BLACK);
                } else {
                    // 此处为失去焦点时的处理内容
                    etUsername.setTextColor(Color.parseColor("#ADADAD"));
                }
            }
        });

        etPassword = view.findViewById(R.id.et_password);
        etPassword.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                MqttService.passWord = s.toString();
                System.out.println(s.toString());
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        etPassword.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if (hasFocus) {
                    // 此处为得到焦点时的处理内容
                    etPassword.setTextColor(Color.BLACK);
                } else {
                    // 此处为失去焦点时的处理内容
                    etPassword.setTextColor(Color.parseColor("#ADADAD"));
                }
            }
        });
        cbPassword = view.findViewById(R.id.cbDisplayPassword);
        cbPassword.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked){//如果选中
                    //显示密码
                    etPassword.setInputType(128);
                }else {
                    //隐藏密码
                    etPassword.setInputType(129);
                }
            }
        });

        etSubTopic = view.findViewById(R.id.et_sub_topic);
        etSubTopic.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                MqttService.subscriptionTopic = s.toString();
                System.out.println(s.toString());
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        etSubTopic.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if (hasFocus) {
                    // 此处为得到焦点时的处理内容
                    etSubTopic.setTextColor(Color.BLACK);
                } else {
                    // 此处为失去焦点时的处理内容
                    etSubTopic.setTextColor(Color.parseColor("#ADADAD"));
                }
            }
        });

        sSubQos = view.findViewById(R.id.s_sub_qos);
        sSubQos.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                MqttService.subQos = position;
                TextView tv = (TextView) view;
                if (tv != null)
                    tv.setTextColor(Color.parseColor("#ADADAD"));
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });

        etPubTopic = view.findViewById(R.id.et_pub_topic);
        etPubTopic.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                MqttService.publishonTopic = s.toString();
                System.out.println(s.toString());
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        etPubTopic.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if (hasFocus) {
                    // 此处为得到焦点时的处理内容
                    etPubTopic.setTextColor(Color.BLACK);
                } else {
                    // 此处为失去焦点时的处理内容
                    etPubTopic.setTextColor(Color.parseColor("#ADADAD"));
                }
            }
        });

        sPubQos = view.findViewById(R.id.s_pub_qos);
        sPubQos.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                MqttService.pubQos = position;
                TextView tv = (TextView) view;
                if (tv != null)
                    tv.setTextColor(Color.parseColor("#ADADAD"));
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });

        btnLogout = view.findViewById(R.id.btn_logout);

        btnLogin = view.findViewById(R.id.btn_login);
        btnLogin.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                //配置信息初始化
                init();
                //组件状态初始化
                flagInit();

                //检测信息是否完整
                if (MqttService.hostName == null || MqttService.port == null || MqttService.userName == null || MqttService.passWord == null ||
                        MqttService.hostName.equals("") || MqttService.port.equals("") || MqttService.userName.equals("") || MqttService.passWord.equals("")){
                    makeToast("配置信息不能为空！");
                }else {
                    if (intent == null){
                        intent = new Intent(getActivity(),MqttService.class);
                    }
                    //启动服务
                    getActivity().bindService(intent ,conn , Context.BIND_AUTO_CREATE);

                    new Thread(new Thread1()).start();

                }

                printInfo();
            }
        });

        btnLogout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                System.out.println("logout外面点击了");
                if(isBind){
                    isBind = !isBind;
                    System.out.println("logout里面点击了");
                    getActivity().unbindService(conn);
                    System.out.println("服务连接断开！");

                    //monitor温湿度初始化
                    MonitorFragment.temp = "0℃";
                    MonitorFragment.humidity = "0%";
                    MonitorFragment.tempTime = "";
                    MonitorFragment.humidityTime = "";

                    //样式初始化
                    Resources resources = getContext().getResources();
                    Drawable btnDrawable = resources.getDrawable(R.drawable.bg_btn5);
                    btnLogout.setBackgroundDrawable(btnDrawable);
                    btnLogoutFlag = false;
                }
            }
        });

        if (btnLogoutFlag){
            //断开 按钮样式初始化
            Resources resources = getContext().getResources();
            Drawable btnDrawable = resources.getDrawable(R.drawable.bg_btn4);
            btnLogout.setBackgroundDrawable(btnDrawable);
        }
    }

    //将EditText中文本信息赋值到MqttService的静态属性中
    private void init(){
        MqttService.hostName = etHostName.getText().toString();
        MqttService.port = etPort.getText().toString();
        MqttService.userName = etUsername.getText().toString();
        MqttService.passWord = etPassword.getText().toString();
        MqttService.subscriptionTopic = etSubTopic.getText().toString();
        MqttService.publishonTopic = etPubTopic.getText().toString();
    }

    private void printInfo(){

//        System.out.println("主机名：" + MqttService.hostName);
//        System.out.println("端口号：" + MqttService.port);
//        System.out.println("用户名：" + MqttService.userName);
//        System.out.println("密码：" + MqttService.passWord);
//        System.out.println("订阅主题：" + MqttService.subscriptionTopic);
//        System.out.println("订阅Qos：" + MqttService.subQos);
//        System.out.println("发布主题：" + MqttService.publishonTopic);
//        System.out.println("发布Qos：" + MqttService.pubQos);
    }

    public void makeToast(String message){
        Toast.makeText(mContext,message,Toast.LENGTH_SHORT).show();
    }

    //组件状态初始化
    public void flagInit(){
        MonitorFragment.lamp1Flag = true;
        MonitorFragment.tempFlag = -1;
        MonitorFragment.humidityFlag = -1;
    }

    class Thread1 implements Runnable{

        @Override
        public void run() {
            while (true){
                try {
                    Thread.sleep(100);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                if (btnLogoutFlag == true){
                    Resources resources = getContext().getResources();
                    Drawable btnDrawable = resources.getDrawable(R.drawable.bg_btn4);
                    btnLogout.setBackgroundDrawable(btnDrawable);
                    return;
                }
            }
        }
    }
}


